#import <appkit/appkit.h>
#import <misckit/MiscString.h>
#import <misckit/MiscStringArray.h>

#define NTY_BD_BOLD_MARK 0
#define NTY_BD_ITALIC_MARK 1
#define NTY_BD_CUSTOM_MARK 2
#ifndef ALIKE
#define ALIKE 2
#endif

typedef struct	{
					int			markiert;
					BOOL		enabled;
					BOOL		blatt;
					id			kinder;
					int			leer;
					char		inhalt;
				} Knoten;

@interface NTYBrowserData:Object
{
    id				browser;
	id				delegate;
	BOOL			browserView;
	unsigned short	pathSeparator;
	int				minColumnWidth;
	unsigned short	markType;
	char			tokenSeparator;
	unsigned int	token;
	char			indentCharacter;
	unsigned int	indentDivisor;
	BOOL			uniqueNodes;
	BOOL			separatorAtStart;
	BOOL			sort;
	unsigned int	updateDisabled;
	char			initDataFile[MAXPATHLEN+1];
	char			initFileAutosaveName[128];
	char			viewTypeAutosaveName[128];

	@private;
	NXZone			*datenzone;
	id				liste;
	Knoten			*baum;
	BOOL			istErwacht;
	DPSTimedEntry	waitLoop;
	int				waitTime;
}

+ (void)removeInitFileUsingName:(const char*)name;
+ (void)removeViewTypeUsingName:(const char*)name;

- setInitDataFile:(const char*)path;
- (char*)initDataFile;
- (BOOL)setInitFileAutosaveName:(const char*)name;
- (BOOL)setViewTypeAutosaveName:(const char*)name;
- (const char*)initFileAutosaveName;
- (const char*)viewTypeAutosaveName;
- (void)saveInitFile:(const char*)path usingName:(const char*)name;
- (void)saveViewTypeUsingName:(const char*)name;
- (BOOL)setViewTypeUsingName:(const char*)name;

- setBrowser:browserId;
- browser;
- (BOOL)isCurrentDataProvider;
- setDelegate:anObject;
- delegate;
- setPathSeparator:(unsigned short)charCode;
- (unsigned short)pathSeparator;
- setMinColumnWidth:(int)columnWidth;
- (int)minColumnWidth;
- setSeparatorAtStart:(BOOL)yn;
- (BOOL)separatorAtStart;
- setMarkType:(unsigned short)mark;
- (unsigned short)markType;
- setToken:(unsigned int)number;
- (unsigned int)token;
- setTokenSeparator:(char)charCode;
- (char)tokenSeparator;
- setIndentChar:(char)charCode;
- (char)indentChar;
- setIndentDivisor:(unsigned int)divisor;
- (unsigned int)indentDivisor;
- setUniqueNodes:(BOOL)yn;
- (BOOL)uniqueNodes;
- setSort:(BOOL)yn;
- (BOOL)sortIsSet;

- readDataFromStream:(NXStream*)stream;
- readDataFromFile:(const char*)path;
- empty;

- setBrowserView:sender;
- setListView:sender;
- (BOOL)browserView;
- updateBrowser:sender;
- updateBrowserAndSelectPaths:pathList;
- reenableUpdateWithChanges:(BOOL)yn;
- disableUpdate;
- (BOOL)isUpdateDisabled;


- selectPaths:pathList;
- markPaths:pathList;
- unmarkPaths:pathList;
- enablePaths:pathList;
- disablePaths:pathList;
- addPaths:pathList;
- removePaths:pathList;

- selectPath:(const char*)path;
- markPath:(const char*)path;
- unmarkPath:(const char*)path;
- enablePath:(const char*)path;
- disablePath:(const char*)path;
- addPath:(const char*)path;
- addPath:(const char*)path withLineNumber:(int)number;
- removePath:(const char*)path;

- getPaths;
- getSelectedPaths;
- getSelectedPathsByLines;
- getMarkedPaths;
- getMarkedPathsByLines;
- (int)getLineForPath:(const char*)path;


- (char*)findPath:(const char*)searchString startPath:(const char*)pathString backwards:(BOOL)backwards caseSensitive:(BOOL)caseSensitive regEx:(BOOL)regEx alsoDisabled:(BOOL)disabled;
- (int)doesPathExist:(const char*)path;
- (int)doesPathExist:(const char*)path marked:(BOOL)markedFlag disabled:(BOOL)disabledFlag;
- up:sender;
- down:sender;

@end



@interface NXBrowserCell(NTYBrowserData_CellProtocol)
- setCustomMark;
@end


@interface Object(NTYBrowserData_DelegateProtocol)
- browserHasBeenUpdated:sender;
@end


@interface NXBrowser(NTYBrowserData)
- selectPaths:pathList;
- selectPath:(const char*)path;
- getSelectedPaths;
- getSelectedPathsByLines;
- up:sender;
- down:sender;
@end

